# $Id: sprawdz.awk,v 1.41 2009-10-18 21:59:41 art Exp $ vim: set ts=4i ic:
#
# skrypt sprawdza:
#  czy rondo (linia typ 0xc) ma kierunek (DirIndicator)
#  czy jakis element ma typ 0x0
#  czy jakis element ma typ dwubajtowy
#  czy wszystkie drogi sa  na poziomie 0 (dodatkowo sprawdza czy to nie rzeka)
#  czy cos jest na poziomie 1
#  czy jest poi lub obszar w pliku z drogami
#  czy RouteParam ma ustawione oneway
#  czy wielokrotne data0=
#  czy wystepuje konflikt CVS
#  liczy miasta w drogach i powyzej zadanej wartoci wyswietla sugestie wydzielenia
#  czy w drogach z nazwa jest przypisane miasto
#  czy polskie telefony sa poprawne
#  czy liczba nodow w drogach przekracza 128
#  ZABLOKOWANE czy ronda skladaja sie z jednego kawalka
#  czy label2= wystepuje z label=
#  czy jest komentarz dla drg z poprzestawianymi route class i speed limit
#  czy w Label nie ma aby jakichs (
#
# parametr "snp=1" dodaje
#  przypisania do plikw txt (dla plikw podczas edycji)
#

BEGIN { 
	# gawk -v "snp=1" 
	# czyli sprawdz_nie_przypisane
	przypis_do_plikow=snp

	# funkcje ktere maja nie dzialac domyslnie 
	disable = 1;

	#blokada komunikatow dla opcj idx
	idx=0;

	FS="=";

	roadid=0;
	licznik_data=0;
	dummy=0;
	naglowek=0;
	telefon=""
	labeldrugi=0
	lecia=0;
	linia=0;
	
}

function add_wpt(warning,label,dane) {
	if (naglowek==0) {
		printf ("OziExplorer Waypoint File Version 1.1\n") > "0sprawdz.wpt" ;
		printf ("WGS 84\n") >> "0sprawdz.wpt";
		printf ("Reserved 2\n") >> "0sprawdz.wpt";
		printf ("Reserved 3\n") >> "0sprawdz.wpt";
		naglowek=1;
	}
	sub(/^.*=\(/,"", dane);
	gsub(/[()]/,"",dane);
	split (dane,datas,",");

	sub(/^.*=/,"",label);
	gsub(/,/,"",label); # w wpt niedozwolone sa przecinki

	opis = warning " " label;
	if ( datas[3] != 0 ) {
		lat= (datas[1]+datas[3])/2;
		lon= (datas[2]+datas[4])/2;
	} else {
		lat= datas[1];
		lon= datas[2];
	}
	printf ("-1,%s,%0.6f,%0.6f,,0,1,3,255,65535,,,0,0,0,6,0,19\n",opis,lat,lon) >> "0sprawdz.wpt";

}

###################
#zjadamy nie sprawdzane coby szybciej bylo
/^StreetDesc=/ || /^Typ=/ || /^City(Name\Idx)=/ || /^HouseNumber=/ || /^KodPoczt=/ || /^EndLevel=/ { next }


/^\[POLYLINE\]/ || /^\[RGN40\]/ {
	linia=1
	next;
}

/^\[POLYGON\]/ || /^\[RGN80\]/ {
	obszar=1
	next;
}

/^\[POI\]/ || /^\[RGN20\]/ || /^\[RGN10\]/ {
	poi=1
	next;
}

/^Type=/ {
    if (linia==1) {
 	if ( /^Type=0x[0]*[123456789abc]$/ || /^Type=0x16$/ ) {
	# Drogi to 0x01 - 0x0c plus 0x16
		droga=1
	}
	if (/^Type=0xc$/) {
		rondo=1
	} else if (/^Type=0x1f$/) {
		rzeka=1
	} else if (/^Type=0x1[ab]$/) {
		prom=1
	} else if (/^Type=0x[ef]..$/) {
		dwabajty=1
	}
    }
	if ($2~/0x0$/) {
		zerowy=1
	}
	next
}
##^^ koniec sprawdzania Type


### Data
/^Data0=/ {
	licznik_data++
	dane=$0
	nb_nods=split($0,tempik,"(");
	next
}
/^Data1=/ {
	levele=1
	dane=$0
}

linia == 1 && /^Data[1-9]=/ {
	levele_dr=1;
	dane=$0;
	next;
}
#^^ koniec sprawdzania Data 


/^Plik=/ {
	zrodelko=$2
	next
}


### Label
/^Label/ {

	if (/^Label=/) {
		nazwa=$0
	}

	if (/^Label.*Lecia/ || /^Label.*\ lecia/) {
		lecia=1
	}
	if (/^Label.*\(/ ){
		nawias=1
	}

	if (/^Label2=/) {
		nazwa2=$0
	}

	if (/^Label[1-9]=/) {
		labeldrugi=1
	}
 
	# dla perlowcow
	if (/^Label=[Dd][Uu][Mm][Mm][Yy]/) {
		dummy=1
	}

	next
}
#^^ koniec sprawdzania Label

/^Miasto=/ {
	miasto=$2
	next;
}

/^Numbers/ {
	numeracja=1
	next;
}

/^Phone=/ {
	#formatowanie (bez spacji i wewnetrznych) 
	gsub(/ /,"",$0);
	sub(/p.*$/,"",$0);
	sub(/w.*$/,"",$0);

#DOBRE
	#polskie stacjonarne
	if (/^Phone=\+48[ ]?(1[2-8]|2[2-59]|3[2-4]|4[1-468]|5[24-5689]|6[1-3578]|7[13-7]|8[1-79]|9[145])[ ]?.......$/) {
		next;
	} else
	#alarmowe
	if (/^Phone=(9[89][0-9]|112)$/) {
		next
	} else
	#polskie mobilne
	if (/^Phone=\+48[ ]?([34]0|5[01]|6[069]|7[0289]|8[08]|90)[ ]?.......$/ ) {
		next;
	} else
	# taxi i podobne np. +48 22 9696 lub  +48 22 19696
	if (/^Phone=\+48[ ]?[0-9][0-9][1]?9...$/ ){ 
		next;
	}

# ZLE 
	# bez prefixu kraju
	if (/^Phone=[^+]/) {
		telefon=$2;
		next;
	}
	# pozostale sa zle
	if (/^Phone=\+48/) {
		telefon=$2;
		next;
	}

}



/^OrigType=$/ {
	typspecjalny=1;
	next;
}

/^RoadID=/ {
	roadid=1
	next
}

/^DirIndicator=1$/ {
	kierunek=1
	next;
}

# komentarz o routingu
/^;[ ]?[Rr][Oo]/ {
	routekoment1=1;
	next;
}
/^RouteParam=[1-9],[0-9],/ {
	routekoment2=1;
	next;
}
/^RouteParam=[0-9],[1-9],/ {
	routekoment3=1;
	next;
}

# na razie tylko OneWay (3 parametr)
/^RouteParam=0,0,1,0,0,0,0,0,0,0,0,0$/ {
	routeparam=1
}

/^(<<<<|====|>>>>)/ {
	konflikt=1
	next;
}

##################################################################

/^\[END]/ || /^\[END-RGN.*]/ {
	if (linia == 1 && rondo == 1 && kierunek == 0) {
		if (! (zrodelko ~ /szlaki/ )) {
			print "Rondo bez kierunku w "zrodelko"\n"substr(dane,1,70)"\n-----"
			add_wpt("RondBKier",nazwa,dane);
		}
	}
	
	if (zerowy == 1 && dummy == 0 && typspecjalny=0) {
		print "Element typu 0x0 w "zrodelko"\n"substr(dane,1,70)"\n-----"
		add_wpt("Ele0x0",nazwa,dane);
	}

	if (linia == 1 && dwabajty == 1 ) {
		print "Typy dwubajtowe sa przestarzale w "zrodelko"\n"substr(dane,1,70)"\n-----"
		add_wpt("Dwab",nazwa,dane);
	}

	if (linia == 1 && levele_dr == 1 && rzeka=0) {
		print "Droga na poziomie niezerowym w "zrodelko"\n"substr(dane,1,70)" ...\n-----"	
		add_wpt("Drog~Poz0",nazwa,dane);
	} 

	if (linia == 0 && levele == 1  ) {
		if (! (zrodelko ~ /(granice|obszary)/ )) {
			print "Element na poziomie 1 w "zrodelko".\n"substr(dane,1,70)" ...\n-----"
			add_wpt("ElPoz1",nazwa,dane);
		}
	}

	if (obszar == 1 && (zrodelko ~ /(ulice|drogi)/ ) ) {
		print "Obszar w pliku z drogami: "zrodelko"\n"substr(dane,1,70)" ...\n-----"	
		add_wpt("ObszWDrog",nazwa,dane);
	}

	if (poi == 1 && dummy == 0 &&  (zrodelko ~ /(ulice|drogi)/ )) {
		print "POI w pliku z drogami: "zrodelko"\n"substr(dane,1,70)" ...\n-----"	
		add_wpt("POIwDrog",nazwa,dane);
	}

	if (idx==0 && routeparam == 1) {
		print "Ustawienia OneWay w routingu: "zrodelko
		print nazwa"\n"substr(dane,1,70)" ...\n-----"
		add_wpt("OneWay",nazwa,dane);
	}


	if (idx==0 && roadid == 1) {
		print "Wpisy routingowe (RoadID) w "zrodelko". Uzycie 'Generate routing graph' i 'Connect to nearest Nodes' psuje zrodla"
		print nazwa"\n"substr(dane,1,70)" ...\n-----"
		add_wpt("WpisyRou",nazwa,dane);
	}


	if (licznik_data > 1 && (zrodelko ~ /(ulice|drogi)/ ) ) {
		print "Wielokrotne ("licznik_data") Data0 w: "zrodelko". Uzywaj 'Merge' zamiast 'Join'"
		print nazwa"\n"substr(dane,1,70)" ...\n-----"
		add_wpt("Joined",nazwa,dane);
	}

	if (konflikt == 1) {
		print "UWAGA!!! Konflikt CVS w "zrodelko"!!!\n-----"
	}

	# liczymy miasta w drogach
	if ((zrodelko ~ /drogi/ ) && miasto != "" && linia == 1) {
		miasta[miasto]=miasta[miasto]+1
	}
	
	#uwaga na "Label="
	if ((zrodelko ~ /drogi/ ) && miasto == "" && nazwa != "Label=" && prom==0 && droga==1) {
		if (!(nazwa ~ /Label=~\[[^]]*\][^ ]*$/) && !(nazwa ~ /Label=[({?]/)) { # drogi z numerkami
			# TS
			#if (droga==0) printf("Nie-");
			print "Drogi z nazwami bez przypisanych miast w "zrodelko
			print nazwa"\n"substr(dane,1,70)" ...\n-----"
			add_wpt("NazBMiast",nazwa,dane);
		}
	}

	if (lecia==1) {
		print "Zla pisownia \"lecia\": "nazwa" "nazwa2
		add_wpt("Bad-Lecia",nazwa,dane);
	}

	if (nawias==1 && (zrodelko ~ /(ulice|drogi)/ ) ) {
		print "Zastosowano nawias ( zamiast {: "nazwa" "nazwa2
		add_wpt("RoundBracket",nazwa,dane);
	}

	if (telefon != "") {
		print "Niepoprawny numer telefonu w: "zrodelko"."
		print nazwa"\n"substr(dane,1,70)" ...\n-----"
		add_wpt("BadPhone",nazwa,dane);
	}

	if (przypis_do_plikow==1 && zrodelko=="") {
		print "Brak przypisania do pliku"
		print nazwa"\n"substr(dane,1,70)" ...\n-----"
		add_wpt("NoFile",nazwa,dane);
	}

#	if (nb_nods > 128 && (zrodelko ~ /(ulice|drogi)/ )) {
#		print "Za duza ilosc nodow "nb_nods" "
#		print nazwa"\n"substr(dane,1,70)" ...\n-----"
#		add_wpt("BigNodNo",nazwa,dane);
#	}
	if (labeldrugi==1 && nazwa == "Label=") {
		print "Label[1|2] bez obecnego Label="
		print substr(dane,1,70)" ...\n-----"
		add_wpt("Lab2Only",nazwa,dane);
	}
	if (idx==0 && routekoment1==0 && (routekoment2==1 || routekoment3==1) ) {
		print "Brak komentarza do zmiany dla RouteClass i SpeedLimit"
		print nazwa"\n"substr(dane,1,70)" ...\n-----"
		add_wpt("NoRouteKom",nazwa,dane);
	}
	
#	if (disable == 0 && linia == 1 && rondo == 1 && numeracja != 1) {
#		nb_nod=split(dane,tempik,",")
#		if (tempik[1] != tempik[nb_nod-1] && tempik[2] != tempik[nb_nod]) {
#			print "Nie zamkniete rondo"
#			print nazwa"\n"substr(dane,1,70)" ...\n-----"
#			add_wpt("ClsRondo",nazwa,dane);
#		}
#	}

	#czyszczenie zmiennych
	linia=0;
	obszar=0;
	poi=0;
	rondo=0;
	kierunek=0;
	zerowy=0;
	dwabajty=0;
	levele=0;
	levele_dr=0;
	rzeka=0;
	roadid=0;
	routeparam=0;
	zrodelko="";
	licznik_data=0;
	nazwa="Label=";  # jak by nie bylo, to label bedzie pusty
	nazwa2="";
	konflikt=0;
	miasto="";
	dummy=0;
	dane="";
	telefon="";
	prom=0;
	nb_nods=0;
	numeracja=0;
	labeldrugi=0;
	droga=0;
	typspecjalny=0;
	routekoment1=0;
	routekoment2=0;
	routekoment3=0;
	lecia=0;
	nawias=0;
	
	next;
}


#########################################################

END {
	for(miasto in miasta) {
		if ( miasta[miasto] > 100 ) {
			print "Warto wydzielic miasto: "miasto" ("miasta[miasto]") do osobnego pliku."
		}
	}
}
